widget_OhMyBash/announcements/urls.py
from django.urls import path

from .views import (
    index,
    AnnouncementsDetailView,
    AnnouncementsCreateView,
    AnnouncementsUpdateView,
)

urlpatterns = [
    path('', index, name='index'),
    path('<int:pk>/details/',
         AnnouncementsDetailView.as_view(),
         name='announcement-details'),
    path('add/',
         AnnouncementsCreateView.as_view(),
         name='announcement-add'),
    path('<int:pk>/edit/',
         AnnouncementsUpdateView.as_view(),
         name='announcement-edit'),

]

app_name = "announcements"

widget_OhMyBash/assignments/urls.py
from django.urls import path
from .views import Assignments, AssignmentDetailView, AssignmentAddView, AssignmentEditView

urlpatterns = [
    path('', Assignments, name="assignments"),
    path('<int:pk>/details/', AssignmentDetailView.as_view(), name='assignment-details'),
    path('add/', AssignmentAddView.as_view(), name='assignment-add'),
    path('<int:pk>/edit/', AssignmentEditView.as_view(), name='assignment-edit'),
]

app_name = 'assignments'

widget_OhMyBash/dashboard/urls.py
from django.urls import path

from .views import (dashboard, WidgetUserDetailView,
                    WidgetUserCreateView, WidgetUserUpdateView)

urlpatterns = [
    path('dashboard/',
         dashboard,
         name='dashboard'),
    path('widgetusers/<int:pk>/details/',
         WidgetUserDetailView.as_view(),
         name='widgetuser-details'),
    path('widgetusers/add/',
         WidgetUserCreateView.as_view(),
         name='widgetuser-create'),
    path('widgetusers/<int:pk>/edit/',
         WidgetUserUpdateView.as_view(),
         name='widgetuser-update'),
]

app_name = "dashboard"

widget_OhMyBash/forum/urls.py
from django.urls import path

from .views import (forum, ForumPostDetailView,
                    ForumPostCreateView, ForumPostUpdateView)

urlpatterns = [
    path('', forum, name='forum'),
    path('forumposts/<int:pk>/details/',
         ForumPostDetailView.as_view(),
         name='forumpost-details'),
    path('forumposts/add/',
         ForumPostCreateView.as_view(),
         name='forumpost-create'),
    path('forumposts/<int:pk>/edit/',
         ForumPostUpdateView.as_view(),
         name='forumpost-update'),
]

app_name = "forum"

widget_OhMyBash/widget_OhMyBash/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('', include('dashboard.urls', namespace="dashboard")),
    path('forum/', include('forum.urls', namespace="forum")),
    path('announcements/', include('announcements.urls', namespace="announcements")),
    path('calendar/', include('widget_calendar.urls', namespace="calendar")),
    path('assignments/', include('assignments.urls', namespace="assignments")),
    path('admin/', admin.site.urls),
]

widget_OhMyBash/widget_calendar/urls.py
from django.urls import path
from .views import (calendar, EventDetailView, EventCreateView, EventUpdateView)

urlpatterns = [
    path('', calendar, name='calendar'),
    path('events/<int:pk>/details/', EventDetailView.as_view(), name='event-details'),
    path('events/add/', EventCreateView.as_view(), name='event-add'),
    path('events/<int:pk>/edit/', EventUpdateView.as_view(), name='event-edit'),

]
# This might be needed, depending on your Django version
app_name = "widget_calendar"

widget_OhMyBash/dashboard/models.py
from django.db import models
from django.urls import reverse


class Department(models.Model):
    dept_name = models.CharField(max_length=255)
    home_unit = models.CharField(max_length=255)

    def __str__(self):
        return '{}, {}'.format(self.dept_name, self.home_unit)


class WidgetUser(models.Model):
    first_name = models.CharField(max_length=255)
    middle_name = models.CharField(max_length=255)
    last_name = models.CharField(max_length=255)
    department = models.ForeignKey(Department, on_delete=models.CASCADE)

    def __str__(self):
        return '{}, {} {}'.format(
            self.last_name,
            self.first_name,
            self.middle_name
        )

    def get_absolute_url(self):
        return reverse('dashboard:widgetuser-details', kwargs={'pk': self.pk})

widget_OhMyBash/dashboard/views.py
from django.shortcuts import render
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView

from .models import WidgetUser


def dashboard(request):
    users = WidgetUser.objects.all()
    return render(request, 'dashboard/dashboard.html', {'users': users})


class WidgetUserDetailView(DetailView):
    model = WidgetUser
    template_name = 'dashboard/widgetuser-details.html'


class WidgetUserCreateView(CreateView):
    model = WidgetUser
    fields = '__all__'
    template_name = 'dashboard/widgetuser-add.html'


class WidgetUserUpdateView(UpdateView):
    model = WidgetUser
    fields = '__all__'
    template_name = 'dashboard/widgetuser-edit.html'

widget_OhMyBash/dashboard/templates/dashboard/dashboard.html
{% extends 'base.html' %}
{% load static %}

{% block title %}Widget v2{% endblock %}

{% block heading %} <h1> Welcome to Widget! </h1> {% endblock %}

{% block content %}
<p>
    WIDGET USERS:<br>
    {% for user in users %}
    <a href="{{ user.get_absolute_url }}">
        {{ user.last_name }}, {{ user.first_name }}
    </a><br>
    {% endfor %}
</p>
{% endblock %}

{% block footing %}
<p class="centerB">
    <a href="{% url 'dashboard:widgetuser-create' %}">
        <button class="btn add">Add Widget User</button>
     </a>
</p>
<p>
    <a href="{% url 'announcements:index' %}">Announcements</a><br>
    <a href="{% url 'forum:forum' %}">Forum</a><br>
    <a href="{% url 'assignments:assignments' %}">Assignments</a><br>
    <a href="{% url 'calendar:calendar' %}">Calendar</a><br>
</p>
{% endblock %}

widget_OhMyBash/dashboard/templates/dashboard/widgetuser-add.html
{% extends 'base.html' %}
{% load static %}

{% block title %}Add Widget User{% endblock %}

{% block heading %}<h1>Add a new Widget User:</h1>{% endblock %}

{% block content %}
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <p class="centerB">
        <input class="submitB" type="submit" value="Add Widget User">
    </p> 
</form>
{% endblock %}

widget_OhMyBash/dashboard/templates/dashboard/widgetuser-details.html
{% extends 'base.html' %}
{% load static %}

{% block title %}{{ object.last_name }}, {{ object.first_name }}{% endblock %}

{% block heading %}
<h1>
    {{ object.first_name }} {{ object.middle_name }} {{ object.last_name }}
</h1>
{% endblock %}

{% block content %}
<p>
    {{ object.department.dept_name }}<br>
    {{ object.department.home_unit }}<br>
</p>
{% endblock %}

{% block footing %}
<p class="centerB">
    <a href="{% url 'dashboard:widgetuser-update' object.pk %}">
        <button class="btn edit">
            Edit Widget User
        </button>
    </a>
</p>

{% endblock %}

widget_OhMyBash/dashboard/templates/dashboard/widgetuser-edit.html
{% extends 'base.html' %}
{% load static %}

{% block title %}Edit Widget User{% endblock %}

{% block heading %} <h1> Edit Widget User: </h1> {% endblock %}

{% block content %}
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <p class="centerB">
        <input class="submitB" type="submit" value="Save Changes to Widget User">
    </p>
</form>
{% endblock %}